
(* 
   no need to change anything in this file except maybe to comment parts out
   before you have done them, but...

   this is only one example client of the Impl interface -- you should
   consider writing more devious or interesting ones (such as running
   programs multiple times)
*)

let parse_file () =
  let argv = Sys.argv in
  let _ = 
    if Array.length argv != 2
    then (prerr_string ("usage: " ^ argv.(0) ^ " [file-to-parse]\n");
	  exit 1) in
  let ch = open_in argv.(1) in
  Parse.program Lex.lexer (Lexing.from_channel ch)

let _ =
  let prog = parse_file() in
  let print_ans s f = 
    print_newline();
    print_string s;
    print_string 
    (try Ast.exp2string (f ()) with
      Impl.TypeError     -> "did not typecheck"
    | Impl.Unimplemented -> "used unimplemented function");
    print_newline() in
  let _ = print_ans "part a:" (fun _ -> Impl.interpret1 prog) in
  let _ = print_ans "part b:" (fun _ -> ignore(Impl.typecheck2 prog); 
                                        Impl.interpret2 prog) in
  let _ = print_ans "part c:" (fun _ -> Impl.typecheck3 prog ()) in
  let _ = print_ans "part d:" (fun _ -> Impl.interpret4(Impl.typecheck4 prog))in
  ()
